## GtkActionable

GtkActionable — An interface for widgets that can be associated with actions

## Functions

const gchar * | gtk_actionable_get_action_name ()
void | gtk_actionable_set_action_name ()
GVariant * | gtk_actionable_get_action_target_value ()
void | gtk_actionable_set_action_target_value ()
void | gtk_actionable_set_action_target ()
void | gtk_actionable_set_detailed_action_name ()

## Properties

gchar * | action-name | Read / Write
GVariant * | action-target | Read / Write

## Types and Values

| GtkActionable
struct | GtkActionableInterface

## Object Hierarchy

        GInterface
        ╰── GtkActionable

## Prerequisites

GtkActionable requires GtkWidget.

## Known Implementations

GtkActionable is implemented by GtkButton, GtkCheckButton, GtkCheckMenuItem, GtkColorButton, GtkFontButton, GtkImageMenuItem, GtkLinkButton, GtkLockButton, GtkMenuButton, GtkMenuItem, GtkMenuToolButton, GtkModelButton, GtkRadioButton, GtkRadioMenuItem, GtkRadioToolButton, GtkScaleButton, GtkSeparatorMenuItem, GtkSwitch, GtkTearoffMenuItem, GtkToggleButton, GtkToggleToolButton, GtkToolButton and GtkVolumeButton.

## Includes

    #include <gtk/gtk.h>

## Description

This interface provides a convenient way of associating widgets with actions on a GtkApplicationWindow or GtkApplication.

It primarily consists of two properties: “action-name” and “action-target”. There are also some convenience APIs for setting these properties.

The action will be looked up in action groups that are found among the widgets ancestors. Most commonly, these will be the actions with the “win.” or “app.” prefix that are associated with the GtkApplicationWindow or GtkApplication, but other action groups that are added with `gtk_widget_insert_action_group()` will be consulted as well.

## Functions

### gtk_actionable_get_action_name ()

    const gchar *
    gtk_actionable_get_action_name (GtkActionable *actionable);

Gets the action name for `actionable` .

See `gtk_actionable_set_action_name()` for more information.

#### Parameters

actionable | a GtkActionable widget |

#### Returns

the action name, or `NULL` if none is set.

[nullable]

Since: 3.4

### gtk_actionable_set_action_name ()

    void
    gtk_actionable_set_action_name (GtkActionable *actionable,
                                    const gchar *action_name);

Specifies the name of the action with which this widget should be associated. If `action_name` is `NULL` then the widget will be unassociated from any previous action.

Usually this function is used when the widget is located (or will be located) within the hierarchy of a GtkApplicationWindow.

Names are of the form “win.save” or “app.quit” for actions on the containing GtkApplicationWindow or its associated GtkApplication, respectively. This is the same form used for actions in the GMenu associated with the window.

#### Parameters

actionable | a GtkActionable widget |
action_name | an action name, or `NULL`. | [nullable]

Since: 3.4

### gtk_actionable_get_action_target_value ()

    GVariant *
    gtk_actionable_get_action_target_value
                                   (GtkActionable *actionable);

Gets the current target value of `actionable` .

See `gtk_actionable_set_action_target_value()` for more information.

#### Parameters

actionable | a GtkActionable widget |

#### Returns

the current target value.

[transfer none]

Since: 3.4

### gtk_actionable_set_action_target_value ()

    void
    gtk_actionable_set_action_target_value
                                   (GtkActionable *actionable,
                                    GVariant *target_value);

Sets the target value of an actionable widget.

If `target_value` is `NULL` then the target value is unset.

The target value has two purposes. First, it is used as the parameter to activation of the action associated with the GtkActionable widget. Second, it is used to determine if the widget should be rendered as “active” — the widget is active if the state is equal to the given target.

Consider the example of associating a set of buttons with a GAction with string state in a typical “radio button” situation. Each button will be associated with the same action, but with a different target value for that action. Clicking on a particular button will activate the action with the target of that button, which will typically cause the action’s state to change to that value. Since the action’s state is now equal to the target value of the button, the button will now be rendered as active (and the other buttons, with different targets, rendered inactive).

#### Parameters

actionable | a GtkActionable widget |
target_value | a GVariant to set as the target value, or `NULL` |

Since: 3.4

### gtk_actionable_set_action_target ()

    void
    gtk_actionable_set_action_target (GtkActionable *actionable,
                                      const gchar *format_string,
                                      ...);

Sets the target of an actionable widget.

This is a convenience function that calls `g_variant_new()` for `format_string` and uses the result to call `gtk_actionable_set_action_target_value()`.

If you are setting a string-valued target and want to set the action name at the same time, you can use `gtk_actionable_set_detailed_action_name()`.

#### Parameters

actionable | a GtkActionable widget |
format_string | a GVariant format string |
... | arguments appropriate for `format_string` |

Since: 3.4

### gtk_actionable_set_detailed_action_name ()

    void
    gtk_actionable_set_detailed_action_name
                                   (GtkActionable *actionable,
                                    const gchar *detailed_action_name);

Sets the action-name and associated string target value of an actionable widget.

This allows for the effect of both `gtk_actionable_set_action_name()` and `gtk_actionable_set_action_target_value()` in the common case that the target is string-valued.

`detailed_action_name` is a string of the form `"action::target"` where `action` is the action name and `target` is the string to use as the target.

#### Parameters

actionable | a GtkActionable widget |
detailed_action_name | the detailed action name |

Since: 3.4

## Types and Values

### GtkActionable

    typedef struct _GtkActionable GtkActionable;

An opaque pointer type.

### struct GtkActionableInterface

    struct GtkActionableInterface {
      const gchar * (* get_action_name)             (GtkActionable *actionable);
      void          (* set_action_name)             (GtkActionable *actionable,
                                                     const gchar   *action_name);
      GVariant *    (* get_action_target_value)     (GtkActionable *actionable);
      void          (* set_action_target_value)     (GtkActionable *actionable,
                                                     GVariant      *target_value);
    };

The interface vtable for GtkActionable.

#### Members

`get_action_name` () | virtual function for `gtk_actionable_get_action_name()` |
`set_action_name` () | virtual function for `gtk_actionable_set_action_name()` |
`get_action_target_value` () | virtual function for `gtk_actionable_get_action_target_value()` |
`set_action_target_value` () | virtual function for `gtk_actionable_set_action_target_value()` |

## Property Details

### The `“action-name”` property

      “action-name”              gchar *

The name of the associated action, like 'app.quit'.

Flags: Read / Write

Default value: NULL

### The `“action-target”` property

      “action-target”            GVariant *

The parameter for action invocations.

Flags: Read / Write

Allowed values: GVariant<*>

Default value: NULL